string sInt(Int_t number)
{
    stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
}
bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
		
	return false;
}
double eps=1e-15;//absolut difference
double releps=1e-10;//relative difference

bool IsEqual1(double a,double b , double eps,double releps)
{
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
		
	return false;
}
double eps1=0.1;//absolut difference
double releps1=0.1;//relative difference
  

  
void plot_totalMassAttenuation(std::vector<double>& x_energy,std::vector<double>& y_nist_total, 
std::vector<double>& y_epics2017_total, std::vector<double>& y_livermore_total, string& Material)
{
	gROOT->Reset();
	
	TString title;
	title = "Total mass attenuation for " + Material;
	TCanvas* mycanvas = new TCanvas(Material.c_str(),"Conversion of electrons and gammas",800, 50, 1000,800);
		
		mycanvas->SetGrid();
		mycanvas->Divide(1,2);
		mycanvas->cd(1);
		gPad->SetGrid();
		gPad->SetLogx();
		gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
	
		
		auto mg = new TMultiGraph();
		TGraph *xcom = new TGraph(x_energy.size(),x_energy.data(),y_nist_total.data());		
		TGraph *epics2017 = new TGraph(x_energy.size(),x_energy.data(),y_epics2017_total.data());		
		TGraph *livermore = new TGraph(x_energy.size(),x_energy.data(),y_livermore_total.data());

		//region 3
		xcom->SetMarkerStyle(24); 
		xcom->SetMarkerSize(1);
		xcom->SetMarkerColor(kGreen);
		//xcom->SetLineWidth(2);
		xcom->SetLineColor(kGreen);	
		mg->Add(xcom);
		
		epics2017->SetMarkerStyle(22);  // red point
		epics2017->SetMarkerSize(1.2);
		epics2017->SetMarkerColor(kRed);
		//epics2017->SetLineWidth(2);
		epics2017->SetLineColor(kRed);	
		mg->Add(epics2017);
		
		livermore->SetMarkerStyle(5);  // red point
		livermore->SetMarkerSize(1.3);
		livermore->SetMarkerColor(kBlue);
		//livermore->SetLineWidth(2);
		livermore->SetLineColor(kBlue);	
		mg->Add(livermore);
		
		
		// // //set graph parameters of livermore
		
		
		mg->Draw("AP");
				
		mg->SetTitle(title);		
		mg->GetXaxis()->SetTitle("Energy (MeV)");
		mg->GetYaxis()->SetTitle("Mass Attenuation Coefficient");
		
		mg->GetXaxis()->SetTitleSize(0.06);
		mg->GetYaxis()->SetTitleSize(0.06);
		
		mg->GetXaxis()->SetLabelSize(0.05);
		mg->GetYaxis()->SetLabelSize(0.05);
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		
		TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		leg->SetTextSize(0.04);
		
		TString rname1 = "XCOM";
		TString rname11 = "EPICS2017";
		TString rname111 = "Livermore";
		
		
		leg->AddEntry(xcom,rname1);
		leg->AddEntry(epics2017,rname11);
		leg->AddEntry(livermore,rname111);
		
		//leg1->DrawClone("Same");
		leg->Draw();
		
		//********************************************
		vector<double> ratio_epics2017;
		vector<double> ratio_livermore;
		for(int i = 0; i<x_energy.size();i++)
		{
			double ratio1 = (y_epics2017_total[i]-y_nist_total[i])/y_nist_total[i]*100;
			double ratio2 = (y_livermore_total[i]-y_nist_total[i])/y_nist_total[i]*100;
			ratio_epics2017.push_back(ratio1);
			ratio_livermore.push_back(ratio2);
		}
		
		mycanvas->cd(2);
		gPad->SetGrid();
		gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		
		auto mg1 = new TMultiGraph();
		TGraph *Ratio1 = new TGraph(x_energy.size(),x_energy.data(),ratio_epics2017.data());
		TGraph *Ratio2 = new TGraph(x_energy.size(),x_energy.data(),ratio_livermore.data());
		
		Ratio1->SetMarkerStyle(22);  // red point
		Ratio1->SetMarkerSize(1.2);
		Ratio1->SetMarkerColor(kRed);
		//Ratio1->SetLineWidth(2);
		Ratio1->SetLineColor(kRed);	
		mg1->Add(Ratio1);
		
		Ratio2->SetMarkerStyle(5);  // red point
		Ratio2->SetMarkerSize(1.3);
		Ratio2->SetMarkerColor(kBlue);
		//Ratio2->SetLineWidth(2);
		Ratio2->SetLineColor(kBlue);	
		mg1->Add(Ratio2);
		
		
		// // //set graph parameters of livermore
		
		
		mg1->Draw("AP");
				
		mg1->SetTitle(title);		
		mg1->GetXaxis()->SetTitle("Energy (MeV)");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		mg1->GetXaxis()->SetTitleSize(0.06);
		mg1->GetYaxis()->SetTitleSize(0.06);
		
		mg1->GetXaxis()->SetLabelSize(0.05);
		mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		
		TLegend* leg1 = new TLegend(0.12,0.15,0.35,0.3);
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
	
		leg1->AddEntry(Ratio1,rname11);
		leg1->AddEntry(Ratio2,rname111);
		
		//leg1->DrawClone("Same");
		// leg1->Draw();
		
		TString figureName = Material+ ".png";
		mycanvas->Print("plots/MassAttenuationCoefficientTotal/"+figureName);
		delete mycanvas;
		mycanvas = NULL;
		// mycanvas->Close();
		
		
}


void plot_Comparison(std::vector<double>& x_energy,std::vector<double>& y_nist, 
std::vector<double>& y_epics2017, std::vector<double>& y_livermore, string& Material, int Z, string& Process)
{
	gROOT->Reset();
	
	printf("----------for %s Process----------\n", Process.c_str());
	
	double windowSize = 400;
	
	TString title;
	title = "Mass attenuation coefficient of " + Process + " for " + Material;
	string name = Process + "  "+ Material;
	string name1 = Process + "1";
	TCanvas* mycanvas = new TCanvas(name.c_str(),"Conversion of electrons and gammas",300, 0, 400,400);
		
		// mycanvas->Divide(1,2);
		// mycanvas->cd(1);
		gPad->SetGrid();
		gPad->SetLogx();
		gPad->SetLogy();
		
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
	
		
		auto mg = new TMultiGraph();
		TGraph *xcom = new TGraph(x_energy.size(),x_energy.data(),y_nist.data());		
		TGraph *epics2017 = new TGraph(x_energy.size(),x_energy.data(),y_epics2017.data());		
		TGraph *livermore = new TGraph(x_energy.size(),x_energy.data(),y_livermore.data());

		
		
		epics2017->SetMarkerStyle(24);  // red point
		epics2017->SetMarkerSize(2);
		epics2017->SetMarkerColor(kRed);
		//epics2017->SetLineWidth(2);
		epics2017->SetLineColor(kRed);	
		mg->Add(epics2017);
		
		livermore->SetMarkerStyle(25);  
		livermore->SetMarkerSize(1.3);
		livermore->SetMarkerColor(kBlue);
		//livermore->SetLineWidth(2);
		livermore->SetLineColor(kBlue);	
		mg->Add(livermore);
		
		//region 3
		xcom->SetMarkerStyle(22); 
		xcom->SetMarkerSize(1.2);
		xcom->SetMarkerColor(kGreen);
		//xcom->SetLineWidth(2);
		xcom->SetLineColor(kGreen);	
		mg->Add(xcom);
		
		
		// // //set graph parameters of livermore
		
		
		mg->Draw("AP");
				
		// mg->SetTitle(title);		
		mg->GetXaxis()->SetTitle("Energy (MeV)");
		mg->GetYaxis()->SetTitle("Mass attenuation coefficient (cm^{2}/g)");
		
		// mg->GetXaxis()->SetTitleSize(0.05);
		// mg->GetYaxis()->SetTitleSize(0.05);
		
		// mg->GetXaxis()->SetLabelSize(0.05);
		// mg->GetYaxis()->SetLabelSize(0.05);
		mg->GetXaxis()->SetTitleOffset(1.5);
		mg->GetYaxis()->SetTitleOffset(2);
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		
		
		
		// TGaxis *axisX = new TGaxis(gPad->GetUxmin(),gPad->GetUymax(),
		// gPad->GetUxmax(), gPad->GetUymax(),
		// mg->GetXaxis()->GetXmin(),
		// mg->GetXaxis()->GetXmax(), 510,"U-");
		// // axis->SetLineColor(kRed);
		// // axis->SetLabelColor(kRed);
		// axisX->Draw("");
		
		TGaxis *axisX = new TGaxis(TMath::Power(10, gPad->GetUxmin()),TMath::Power(10,gPad->GetUymax()),
		TMath::Power(10, gPad->GetUxmax()), TMath::Power(10, gPad->GetUymax()),
		mg->GetXaxis()->GetXmin(),
		mg->GetXaxis()->GetXmax(), 510,"GU-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX->Draw("");
		
	
		TGaxis *axisY = new TGaxis(TMath::Power(10, gPad->GetUxmax()), TMath::Power(10, gPad->GetUymin()),
		TMath::Power(10, gPad->GetUxmax()), TMath::Power(10, gPad->GetUymax()),
		mg->GetYaxis()->GetXmin(),
		mg->GetYaxis()->GetXmax(), 510,"GU+");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY->Draw();
		
		
		
		
		
		
		
		TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		// leg->SetTextSize(0.04);
		
		TString rname1 = "XCOM";
		TString rname11 = "EPICS2017";
		TString rname111 = "Livermore";
		
		
		leg->AddEntry(xcom,rname1);
		leg->AddEntry(epics2017,rname11);
		leg->AddEntry(livermore,rname111);
		
		//leg1->DrawClone("Same");
		// leg->Draw();
		
		TString figureName = Material+ " "+ Process + ".png";
		if(!Process.compare("gamma conversion"))
		{
			mycanvas->Print("plots/MassAttenuationCoefficient_pair/"+figureName);
		}		
		else if(!Process.compare("Compton effect"))
		{
			mycanvas->Print("plots/MassAttenuationCoefficient_compt/"+figureName);
		}
		else if(!Process.compare("photoelectric"))
		{
			mycanvas->Print("plots/MassAttenuationCoefficient_phot/"+figureName);
		}
		else if(!Process.compare("Rayleigh scattering"))
		{
			mycanvas->Print("plots/MassAttenuationCoefficient_rayl/"+figureName);
		}
		else if (!Process.compare("total"))
		{
			mycanvas->Print("plots/MassAttenuationCoefficient_total/"+figureName);
		}
		
		delete mycanvas;
		mycanvas = NULL;
		// mycanvas->Close();
		
		//********************************************
		vector<double> ratio_epics2017;
		vector<double> ratio_livermore;
		for(int i = 0; i<x_energy.size();i++)
		{
			if(y_nist[i] ==0) 
			{
				ratio_epics2017.push_back(0.);
				ratio_livermore.push_back(0.);
				continue;
			}
			double ratio1 = (y_epics2017[i]-y_nist[i])/y_nist[i]*100;
			double ratio2 = (y_livermore[i]-y_nist[i])/y_nist[i]*100;
			ratio_epics2017.push_back(ratio1);
			ratio_livermore.push_back(ratio2);
			printf("ratio for EPICS2017 and Livermore at %.9e MeV %.9e %.9e\n",x_energy[i], ratio1, ratio2 );
		}
		
		TCanvas* mycanvas1 = new TCanvas(name1.c_str(),"Conversion of electrons and gammas",900, 0, windowSize,windowSize);
		// mycanvas->cd(2);
		gPad->SetGrid();
		gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		
		auto mg1 = new TMultiGraph();
		TGraph *Ratio1 = new TGraph(x_energy.size(),x_energy.data(),ratio_epics2017.data());
		TGraph *Ratio2 = new TGraph(x_energy.size(),x_energy.data(),ratio_livermore.data());
		
		Ratio1->SetMarkerStyle(24);  // red point
		Ratio1->SetMarkerSize(1.2);
		Ratio1->SetMarkerColor(kRed);
		//Ratio1->SetLineWidth(2);
		Ratio1->SetLineColor(kRed);	
		mg1->Add(Ratio1);
		
		Ratio2->SetMarkerStyle(21);  // red point
		Ratio2->SetMarkerSize(0.8);
		Ratio2->SetMarkerColor(kBlue);
		//Ratio2->SetLineWidth(2);
		Ratio2->SetLineColor(kBlue);	
		mg1->Add(Ratio2);
		
		
		// // //set graph parameters of livermore
		
		
		mg1->Draw("AP");
		
		TString title1 = "Relative difference compared with XCOM for " + Material;
	
		
		// mg1->SetTitle(title1);		
		mg1->GetXaxis()->SetTitle("Energy (MeV)");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		// mg1->GetXaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleSize(0.06);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		
		mg1->GetXaxis()->SetTitleOffset(1.5);
		mg1->GetYaxis()->SetTitleOffset(2);
		

	
		
		TGaxis *axisX1 = new TGaxis(TMath::Power(10, gPad->GetUxmin()),gPad->GetUymax(),
		TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
		mg1->GetXaxis()->GetXmin(),
		mg1->GetXaxis()->GetXmax(), 510,"GU-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX1->Draw("");
		
		TGaxis *axisY1 = new TGaxis(TMath::Power(10, gPad->GetUxmax()),gPad->GetUymin(),
		TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
		mg1->GetYaxis()->GetXmin(),
		mg1->GetYaxis()->GetXmax(), 510,"U+");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY1->Draw();
		
		
		
		TLegend* leg1 = new TLegend(0.12,0.15,0.35,0.3);
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
	
		leg1->AddEntry(Ratio1,rname11);
		leg1->AddEntry(Ratio2,rname111);
		
		//leg1->DrawClone("Same");
		// leg1->Draw();
		
		if(!Process.compare("gamma conversion"))
		{
			mycanvas1->Print("plots/MassAttenuationCoefficient_pair/RD/"+figureName);
		}		
		else if(!Process.compare("Compton effect"))
		{
			mycanvas1->Print("plots/MassAttenuationCoefficient_compt/RD/"+figureName);
		}
		else if(!Process.compare("photoelectric"))
		{
			mycanvas1->Print("plots/MassAttenuationCoefficient_phot/RD/"+figureName);
		}
		else if(!Process.compare("Rayleigh scattering"))
		{
			mycanvas1->Print("plots/MassAttenuationCoefficient_rayl/RD/"+figureName);
		}
		else if (!Process.compare("total"))
		{
			mycanvas1->Print("plots/MassAttenuationCoefficient_total/RD/"+figureName);
		}
		
		delete mycanvas1;
		mycanvas1 = NULL;
		// mycanvas1->Close();
		
		
}

		
void Write_RatioMax_Average(std::vector<double>& x_energy,std::vector<double>& y_nist, std::vector<double>& y_target, char* dir, string& Process)
{
	printf("----------for %s Process----------\n", Process.c_str());
	double ratioMax = 0;
	double sum = 0;
	int loop = 0;
	for(int i = 0; i<x_energy.size();i++)
	{
		double ratio;
		// printf("-------%d %.9e %.9e %.9e\n",i+1, x_energy[i], y_nist[i], y_target[i]);
		ratio = (y_target[i]-y_nist[i])/y_nist[i]*100;
		if(abs(ratio)>abs(ratioMax))
		{
			ratioMax = ratio;
		}
		
		sum+=abs(ratio);
		
		
	}
	
	
	sum/=x_energy.size();
	
	FILE * fp = fopen(dir,"a+");
	fprintf(fp,"%.9e\t%.9e\t", ratioMax, sum);
	// printf("%.9e\t%.9e\t", ratioMax, sum);
	fclose(fp);
	
	printf("\n");
	
}		
  
void Analysis()
{
		// cout<<TMath::Power(10,2)<<endl;
	// gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_total");
	// gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_pair");
	// gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_compt");
	// gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_phot");
	// gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_rayl");
	
	gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_total/RD");
	gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_pair/RD");
	gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_compt/RD");
	gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_phot/RD");
	gSystem->Exec("mkdir -p plots/MassAttenuationCoefficient_rayl/RD");

	int check = 0;  // check for all the materials if 50 points can be found for XCOM
	double energies[50] = {0.001, 1.50E-03, 2.000000000E-03, 3.00E-003, 0.004, 0.005, 6.00E-03, 0.008, 0.01, 0.015,
							0.02, 0.03, 0.04, 0.05, 0.06, 0.08, 0.1, 1.50E-01, 0.2, 0.3, 
							0.4, 0.5, 0.6, 0.8, 1, 1.022, 1.25, 1.5, 2, 2.044, 
							3, 4, 5, 6, 7, 8, 9, 10, 15, 20, 
							50, 100, 500, 1000, 5000, 10000, 50000, 60000, 80000, 100000};
	string Materials[20] = {"Be", "C", "Al", "Si", "Fe", "Ge", "Ag", "Cs", "Au", "Pb", "U", "Water", "BONE_COMPACT_ICRU"};
	int MaterialsAtomicNum[20] = {4, 6, 13, 14, 26, 32, 47, 55, 79, 82, 92, 101, 102};
	
	
	
	
	string Processes[5] = {"gamma conversion","Compton effect","photoelectric", "Rayleigh scattering", "total"};
	
	char file_epics2017[64] = "ratioMax_Average_epics2017.dat";
	char file_livermore[64] = "ratioMax_Average_livermore.dat";
	FILE * fp = fopen(file_epics2017,"w");
	fclose(fp);	
	
	FILE * fp1 = fopen(file_livermore,"w");
	fclose(fp1);
	
	char file_uncertainty_epics2017[64] = "uncertaintyCheck_epics2017.dat";
	char file_uncertainty_livermore[64] = "uncertaintyCheck_livermore.dat";
	
	FILE * fp2 = fopen(file_uncertainty_epics2017,"w");
	fclose(fp2);	
	
	FILE * fp3 = fopen(file_uncertainty_livermore,"w");
	fclose(fp3);
	
	for (int z =0; z<13;z++)  // loop for materials
	{		
		std::vector<double>  x_energy; // Nist
		std::vector<double>  x_energy_pair; // Nist
		std::vector<double>  y_nist_total; 	
		std::vector<double>  y_nist_pair; 	
		std::vector<double>  y_nist_compt; 	
		std::vector<double>  y_nist_phot; 	
		std::vector<double>  y_nist_rayl; 	
		// to remove repeated points
		
		std::vector<double>  y_epics2017_total; // EPICS2017
		std::vector<double>  y_epics2017_pair; 	
		std::vector<double>  y_epics2017_compt; 	
		std::vector<double>  y_epics2017_phot; 	
		std::vector<double>  y_epics2017_rayl; 
		std::vector<double>  uncertainty_epics2017; 
		
		std::vector<double>  y_livermore_total; // Livermore
		std::vector<double>  y_livermore_pair; 	
		std::vector<double>  y_livermore_compt; 	
		std::vector<double>  y_livermore_phot; 	
		std::vector<double>  y_livermore_rayl;
		std::vector<double>  uncertainty_livermore;

		
		
		//read Nist data begin***************************************************
		std::ostringstream ost1;
		// ost1 << "XCOM_data/Water.dat";
		ost1 << "XCOM_data/"<<Materials[z]<<".dat";
		cout<<ost1.str()<<endl;
		std::ifstream fin1(ost1.str().c_str());
		for(int i = 0; i<200; ++i) 
		{
			// printf("---%d \n", i);
			double P[7] = {0};
			fin1 >> P[0] >> P[1]>> P[2] >> P[3]>>P[4] >> P[5]>> P[6];
			
			for(int j = 0; j<50; j++)
			{
				if(P[0] == energies[j])
				{
					static int k = 0;
					printf("1---%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					++k, P[0], P[1], P[2], P[3], P[4], P[5], P[6]);
					x_energy.push_back(P[0]);
					y_nist_total.push_back(P[6]);
					y_nist_rayl.push_back(P[1]);
					y_nist_compt.push_back(P[2]);
					y_nist_phot.push_back(P[3]);
					if(P[0]>1.022)
					{
						// printf("1---%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					// ++k, P[0], P[1], P[2], P[3], P[4], P[5], P[6]);
						x_energy_pair.push_back(P[0]);
						y_nist_pair.push_back(P[4]+P[5]);
					}
					
					break;
				}
				 
				 
			}	
		 
		}		
			
		if (x_energy.size() == 50)
		{
			check++;
			cout<<"50 points are found for "<<Materials[z]<< endl;
		}
		else
		{
			cout<<"50 points are not found for "<<Materials[z]<< endl;
		}
		cout<<"check = "<<check<<endl;
		
	   fin1.close();
	   //read Nist data end***************************************************
		
		//read EPICS2017 data begin***************************************************
		std::ostringstream ost2;
		// ost2 << "epics2017_data/AttenuationCoefficient_Water_epics2017.dat";
		ost2 << "epics2017_data/AttenuationCoefficient_"<<Materials[z]<<"_epics2017.dat";
		std::ifstream fin2(ost2.str().c_str());
		int loop = 0;
		fp2 = fopen(file_uncertainty_epics2017, "a+");
		fprintf(fp2,"Z=%d\t%s\n", MaterialsAtomicNum[z], Materials[z].c_str());
		double ratioMax = 0;
		for(int i = 0; i<50; i++)
		{
			double P[17] = {0};
			fin2 >> P[0] >> P[1]>> P[2] >> P[3]>>P[4] >> P[5]>> P[6]
			>> P[7] >> P[8]>> P[9] >> P[10] >> P[11]>> P[12] >> P[13]
			>>P[14] >> P[15]>> P[16];		
			
			// printf("2---%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					// i+1, P[0], P[1], P[2], P[3], P[4], P[5], P[6],
					// P[7], P[8], P[9], P[10], P[11], P[12], P[13],
					// P[14], P[15], P[16]);
					
			y_epics2017_total.push_back(P[1]);
			uncertainty_epics2017.push_back(P[6]);
			if(IsEqual1(P[11], P[16], eps1, releps1)) 
			{
				
				double ratio = (P[11] - P[16])/P[16] *100;
				fprintf(fp2,"%.9e\t%.9e\n", energies[i], ratio);  // keep the uncertainty for each energy point
				if(abs(ratio)> ratioMax) ratioMax = ratio;
				// cout<<"**********"<<P[0]<<" "<<P[11]<<" "<<P[16]<<endl;
				y_epics2017_rayl.push_back(P[10]/P[5]);
				y_epics2017_compt.push_back(P[8]/P[5]);
				y_epics2017_phot.push_back(P[7]/P[5]);
				if(i>=26)
				{
					// printf("2---%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					// i, P[0], P[1], P[2], P[3], P[4], P[5], P[6]);
					y_epics2017_pair.push_back(P[9]/P[5]);
				}
				
				loop++;
			}
			
			
			 
		}
		fprintf(fp2,"RatioMax=%.9e\n", ratioMax);  // keep the uncertainty for each energy point
		fclose(fp2);
		// cout<<"loop == "<<loop<<endl;
		if(loop == 50) 
		{
			printf("-----------------Two computeCS methods turn the same results for EPICS2017\n");
		}
		fin2.close();
	   //read EPICS217 data end***************************************************
	
	
		// read Livermore data begin***************************************************
		std::ostringstream ost3;
		// ost3 << "livermore_data/AttenuationCoefficient_Water_livermore.dat";
		ost3 << "livermore_data/AttenuationCoefficient_"<<Materials[z]<<"_livermore.dat";
		std::ifstream fin3(ost3.str().c_str());
		loop = 0;
		
		fp3 = fopen(file_uncertainty_livermore, "a+");
		fprintf(fp3,"Z=%d\t%s\n", MaterialsAtomicNum[z], Materials[z].c_str());
		
		ratioMax = 0;
		
		for(int i = 0; i<50; i++)
		{
			double P[17] = {0};
			fin3 >> P[0] >> P[1]>> P[2] >> P[3]>>P[4] >> P[5]>> P[6]
			>> P[7] >> P[8]>> P[9] >> P[10] >> P[11]>> P[12] >> P[13]
			>>P[14] >> P[15]>> P[16];		
			
			// printf("3---%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					// i+1, P[0], P[1], P[2], P[3], P[4], P[5], P[6],
					// P[7], P[8], P[9], P[10], P[11], P[12], P[13],
					// P[14], P[15], P[16]);
					
			y_livermore_total.push_back(P[1]);
			uncertainty_livermore.push_back(P[6]);
			if(IsEqual1(P[11], P[16], eps1, releps1)) 
			{
				double ratio = (P[11] - P[16])/P[16] *100;
				fprintf(fp3,"%.9e\t%.9e\n", energies[i], ratio);  // keep the uncertainty for each energy point
				if(abs(ratio)> ratioMax) ratioMax = ratio;
				
				
				// cout<<"**********"<<P[0]<<" "<<P[11]<<" "<<P[16]<<endl;
				y_livermore_rayl.push_back(P[10]/P[5]);
				y_livermore_compt.push_back(P[8]/P[5]);
				y_livermore_phot.push_back(P[7]/P[5]);
				
				if(i>=26)
				{
					y_livermore_pair.push_back(P[9]/P[5]);
				}
				loop++;
			}
			
			
			
			 
		}
		
		fprintf(fp3,"RatioMax=%.9e\n", ratioMax);  // keep the uncertainty for each energy point
		fclose(fp3);
		
		
		if(loop == 50) 
		{
			printf("-----------------Two computeCS methods turn the same results for Livermore\n");
		}
		fin3.close();
	   // read Livermore data end***************************************************
	   cout<<x_energy.size()<<" "<< y_nist_total.size()<<" "<<y_epics2017_total.size()<<" "<<y_livermore_total.size()<<" "<<Materials[z]<<endl;
	   for(int i=0; i<50; ++i)
	   {
		   // printf("%d %.9e %.9e %.9e %.9e\n", i+1, x_energy[i], y_nist_phot[i], y_epics2017_phot[i], y_livermore_phot[i]);
		   // printf("%d %.9e %.9e %.9e %.9e\n", i+1, x_energy[i], y_nist_total[i], y_epics2017_total[i], y_livermore_total[i]);
		   // printf("%d %.9e %.9e %.9e %.9e\n", i+1, x_energy[i], y_nist_compt[i], y_epics2017_compt[i], y_livermore_compt[i]);
		   // printf("phot: %d %.9e %.9e %.9e %.9e\n", i+1, x_energy[i], y_nist_phot[i], y_epics2017_phot[i], y_livermore_phot[i]);
	   }
	   
		plot_Comparison(x_energy_pair,y_nist_pair, y_epics2017_pair,y_livermore_pair,Materials[z],MaterialsAtomicNum[z],Processes[0]);
		plot_Comparison(x_energy,y_nist_compt, y_epics2017_compt,y_livermore_compt,Materials[z],MaterialsAtomicNum[z],Processes[1]);
		plot_Comparison(x_energy,y_nist_phot, y_epics2017_phot,y_livermore_phot,Materials[z],MaterialsAtomicNum[z],Processes[2]);
		plot_Comparison(x_energy,y_nist_rayl, y_epics2017_rayl,y_livermore_rayl,Materials[z],MaterialsAtomicNum[z],Processes[3]);
		plot_Comparison(x_energy,y_nist_total, y_epics2017_total,y_livermore_total, Materials[z],MaterialsAtomicNum[z],Processes[4]);
		
		
		
		
		
		
		Write_RatioMax_Average(x_energy_pair,y_nist_pair, y_epics2017_pair, file_epics2017, Processes[0]);
		Write_RatioMax_Average(x_energy,y_nist_compt, y_epics2017_compt, file_epics2017, Processes[1]);
		Write_RatioMax_Average(x_energy,y_nist_phot, y_epics2017_phot, file_epics2017, Processes[2]);
		Write_RatioMax_Average(x_energy,y_nist_rayl, y_epics2017_rayl, file_epics2017, Processes[3]);
		Write_RatioMax_Average(x_energy,y_nist_total, y_epics2017_total, file_epics2017,Processes[4]);
		
		Write_RatioMax_Average(x_energy_pair,y_nist_pair, y_livermore_pair, file_livermore, Processes[0]);
		Write_RatioMax_Average(x_energy,y_nist_compt, y_livermore_compt, file_livermore, Processes[1]);
		Write_RatioMax_Average(x_energy,y_nist_phot, y_livermore_phot, file_livermore, Processes[2]);
		Write_RatioMax_Average(x_energy,y_nist_rayl, y_livermore_rayl, file_livermore, Processes[3]);
		Write_RatioMax_Average(x_energy,y_nist_total, y_livermore_total, file_livermore,Processes[4]);
		
		fp = fopen(file_epics2017, "a+");
		fprintf(fp, "\n");
		fclose(fp);	
	
	
		fp1 = fopen(file_livermore, "a+");
		fprintf(fp1, "\n");
		fclose(fp1);
	  
	  	   
	}
	
}	
		
	           
            	
    
   