string sInt(Int_t number)
{
    stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
}
bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
		
	return false;
}
double eps=1e-15;//absolut difference
double releps=1e-10;//relative difference

bool IsEqual1(double a,double b , double eps,double releps)
{
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
		
	return false;
}
double eps1=0.1;//absolut difference
double releps1=0.1;//relative difference
  

  
void plot_totalMassAttenuation(std::vector<double>& x_energy,std::vector<double>& y_nist_total, 
std::vector<double>& y_epics2017_total, std::vector<double>& y_livermore_total, string& Material)
{
	gROOT->Reset();
	
	TString title;
	title = "Total mass attenuation for " + Material;
	TCanvas* mycanvas = new TCanvas(Material.c_str(),"Conversion of electrons and gammas",800, 50, 1000,800);
		
		mycanvas->SetGrid();
		mycanvas->Divide(1,2);
		mycanvas->cd(1);
		gPad->SetGrid();
		gPad->SetLogx();
		gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
	
		
		auto mg = new TMultiGraph();
		TGraph *xcom = new TGraph(x_energy.size(),x_energy.data(),y_nist_total.data());		
		TGraph *epics2017 = new TGraph(x_energy.size(),x_energy.data(),y_epics2017_total.data());		
		TGraph *livermore = new TGraph(x_energy.size(),x_energy.data(),y_livermore_total.data());

		//region 3
		xcom->SetMarkerStyle(24); 
		xcom->SetMarkerSize(1);
		xcom->SetMarkerColor(kGreen);
		//xcom->SetLineWidth(2);
		xcom->SetLineColor(kGreen);	
		mg->Add(xcom);
		
		epics2017->SetMarkerStyle(22);  // red point
		epics2017->SetMarkerSize(1.2);
		epics2017->SetMarkerColor(kRed);
		//epics2017->SetLineWidth(2);
		epics2017->SetLineColor(kRed);	
		mg->Add(epics2017);
		
		livermore->SetMarkerStyle(5);  // red point
		livermore->SetMarkerSize(1.3);
		livermore->SetMarkerColor(kBlue);
		//livermore->SetLineWidth(2);
		livermore->SetLineColor(kBlue);	
		mg->Add(livermore);
		
		
		// // //set graph parameters of livermore
		
		
		mg->Draw("AP");
				
		mg->SetTitle(title);		
		mg->GetXaxis()->SetTitle("Energy (MeV)");
		mg->GetYaxis()->SetTitle("Mass Attenuation Coefficient");
		
		mg->GetXaxis()->SetTitleSize(0.06);
		mg->GetYaxis()->SetTitleSize(0.06);
		
		mg->GetXaxis()->SetLabelSize(0.05);
		mg->GetYaxis()->SetLabelSize(0.05);
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		
		TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		leg->SetTextSize(0.04);
		
		TString rname1 = "XCOM";
		TString rname11 = "EPICS2017";
		TString rname111 = "Livermore";
		
		
		leg->AddEntry(xcom,rname1);
		leg->AddEntry(epics2017,rname11);
		leg->AddEntry(livermore,rname111);
		
		//leg1->DrawClone("Same");
		leg->Draw();
		
		//********************************************
		vector<double> ratio_epics2017;
		vector<double> ratio_livermore;
		for(int i = 0; i<x_energy.size();i++)
		{
			double ratio1 = (y_epics2017_total[i]-y_nist_total[i])/y_nist_total[i]*100;
			double ratio2 = (y_livermore_total[i]-y_nist_total[i])/y_nist_total[i]*100;
			ratio_epics2017.push_back(ratio1);
			ratio_livermore.push_back(ratio2);
		}
		
		mycanvas->cd(2);
		gPad->SetGrid();
		gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		
		auto mg1 = new TMultiGraph();
		TGraph *Ratio1 = new TGraph(x_energy.size(),x_energy.data(),ratio_epics2017.data());
		TGraph *Ratio2 = new TGraph(x_energy.size(),x_energy.data(),ratio_livermore.data());
		
		Ratio1->SetMarkerStyle(22);  // red point
		Ratio1->SetMarkerSize(1.2);
		Ratio1->SetMarkerColor(kRed);
		//Ratio1->SetLineWidth(2);
		Ratio1->SetLineColor(kRed);	
		mg1->Add(Ratio1);
		
		Ratio2->SetMarkerStyle(5);  // red point
		Ratio2->SetMarkerSize(1.3);
		Ratio2->SetMarkerColor(kBlue);
		//Ratio2->SetLineWidth(2);
		Ratio2->SetLineColor(kBlue);	
		mg1->Add(Ratio2);
		
		
		// // //set graph parameters of livermore
		
		
		mg1->Draw("AP");
				
		mg1->SetTitle(title);		
		mg1->GetXaxis()->SetTitle("Energy (MeV)");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		mg1->GetXaxis()->SetTitleSize(0.06);
		mg1->GetYaxis()->SetTitleSize(0.06);
		
		mg1->GetXaxis()->SetLabelSize(0.05);
		mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		
		TLegend* leg1 = new TLegend(0.12,0.15,0.35,0.3);
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
	
		leg1->AddEntry(Ratio1,rname11);
		leg1->AddEntry(Ratio2,rname111);
		
		//leg1->DrawClone("Same");
		leg1->Draw();
		
		TString figureName = Material+ ".png";
		mycanvas->Print("plots/MassAttenuationCoefficientTotal/"+figureName);
		// delete mycanvas;
		// mycanvas = NULL;
			// mycanvas->Close();
		
		
}


void plot_Partial(std::vector<double>& x_energy,std::vector<double>& y_nist, 
std::vector<double>& y_epics2017, std::vector<double>& y_livermore, string& Material, string& Process)
{
	gROOT->Reset();
	
	TString title;
	title = "Mass attenuation coefficient of " + Process + " for " + Material;
	string name = Process + "  "+ Material;
	TCanvas* mycanvas = new TCanvas(name.c_str(),"Conversion of electrons and gammas",800, 50, 1000,800);
		
		mycanvas->SetGrid();
		mycanvas->Divide(1,2);
		mycanvas->cd(1);
		gPad->SetGrid();
		gPad->SetLogx();
		gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
	
		
		auto mg = new TMultiGraph();
		TGraph *xcom = new TGraph(x_energy.size(),x_energy.data(),y_nist.data());		
		TGraph *epics2017 = new TGraph(x_energy.size(),x_energy.data(),y_epics2017.data());		
		TGraph *livermore = new TGraph(x_energy.size(),x_energy.data(),y_livermore.data());

		//region 3
		xcom->SetMarkerStyle(24); 
		xcom->SetMarkerSize(1);
		xcom->SetMarkerColor(kGreen);
		//xcom->SetLineWidth(2);
		xcom->SetLineColor(kGreen);	
		mg->Add(xcom);
		
		epics2017->SetMarkerStyle(22);  // red point
		epics2017->SetMarkerSize(1.2);
		epics2017->SetMarkerColor(kRed);
		//epics2017->SetLineWidth(2);
		epics2017->SetLineColor(kRed);	
		mg->Add(epics2017);
		
		livermore->SetMarkerStyle(5);  // red point
		livermore->SetMarkerSize(1.3);
		livermore->SetMarkerColor(kBlue);
		//livermore->SetLineWidth(2);
		livermore->SetLineColor(kBlue);	
		mg->Add(livermore);
		
		
		// // //set graph parameters of livermore
		
		
		mg->Draw("AP");
				
		mg->SetTitle(title);		
		mg->GetXaxis()->SetTitle("Energy (MeV)");
		mg->GetYaxis()->SetTitle("Mass Attenuation Coefficient");
		
		mg->GetXaxis()->SetTitleSize(0.06);
		mg->GetYaxis()->SetTitleSize(0.06);
		
		mg->GetXaxis()->SetLabelSize(0.05);
		mg->GetYaxis()->SetLabelSize(0.05);
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		if(Process == "gamma conversion")
		{
			mg->GetXaxis()->SetLimits(1,1e5);
		}
		
		TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		leg->SetTextSize(0.04);
		
		TString rname1 = "XCOM";
		TString rname11 = "EPICS2017";
		TString rname111 = "Livermore";
		
		
		leg->AddEntry(xcom,rname1);
		leg->AddEntry(epics2017,rname11);
		leg->AddEntry(livermore,rname111);
		
		//leg1->DrawClone("Same");
		leg->Draw();
		
		//********************************************
		vector<double> ratio_epics2017;
		vector<double> ratio_livermore;
		for(int i = 0; i<x_energy.size();i++)
		{
			if(y_nist[i] ==0) 
			{
				ratio_epics2017.push_back(0.);
				ratio_livermore.push_back(0.);
				continue;
			}
			double ratio1 = (y_epics2017[i]-y_nist[i])/y_nist[i]*100;
			double ratio2 = (y_livermore[i]-y_nist[i])/y_nist[i]*100;
			ratio_epics2017.push_back(ratio1);
			ratio_livermore.push_back(ratio2);
		}
		
		mycanvas->cd(2);
		gPad->SetGrid();
		gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.12);
		
		auto mg1 = new TMultiGraph();
		TGraph *Ratio1 = new TGraph(x_energy.size(),x_energy.data(),ratio_epics2017.data());
		TGraph *Ratio2 = new TGraph(x_energy.size(),x_energy.data(),ratio_livermore.data());
		
		Ratio1->SetMarkerStyle(22);  // red point
		Ratio1->SetMarkerSize(1.2);
		Ratio1->SetMarkerColor(kRed);
		//Ratio1->SetLineWidth(2);
		Ratio1->SetLineColor(kRed);	
		mg1->Add(Ratio1);
		
		Ratio2->SetMarkerStyle(5);  // red point
		Ratio2->SetMarkerSize(1.3);
		Ratio2->SetMarkerColor(kBlue);
		//Ratio2->SetLineWidth(2);
		Ratio2->SetLineColor(kBlue);	
		mg1->Add(Ratio2);
		
		
		// // //set graph parameters of livermore
		
		
		mg1->Draw("AP");
		
		TString title1 = "Relative difference compared with XCOM for " + Material;
	
		
		mg1->SetTitle(title1);		
		mg1->GetXaxis()->SetTitle("Energy (MeV)");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		mg1->GetXaxis()->SetTitleSize(0.06);
		mg1->GetYaxis()->SetTitleSize(0.06);
		
		mg1->GetXaxis()->SetLabelSize(0.05);
		mg1->GetYaxis()->SetLabelSize(0.05);
		
		
		mg1->GetXaxis()->CenterTitle();
		mg1->GetYaxis()->CenterTitle();
		if(Process == "gamma conversion")
		{
			mg1->GetXaxis()->SetLimits(1,1e5);
		}
		TLegend* leg1 = new TLegend(0.12,0.15,0.35,0.3);
		// TLegend* leg1 = new TLegend(0.5,0.7,0.9,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
	
		leg1->AddEntry(Ratio1,rname11);
		leg1->AddEntry(Ratio2,rname111);
		
		//leg1->DrawClone("Same");
		leg1->Draw();
		
		TString figureName = Material+ " "+ Process + ".png";
		mycanvas->Print("plots/MassAttenuationCoefficientPartial/"+figureName);
		// delete mycanvas;
		// mycanvas = NULL;
			// mycanvas->Close();
		
		
}
  
  
void Analysis()
{
	gSystem->Exec("mkdir -p plots/MassAttenuationCoefficientTotal");
	gSystem->Exec("mkdir -p plots/MassAttenuationCoefficientPartial");
	double e; //energy 
	double cs; // cross section
    Int_t ncols = 0;
	double energies[50] = {0.001, 1.50E-03, 2.000000000E-03, 3.00E-03, 0.004, 0.005, 6.00E-03, 0.008, 0.01, 0.015,
							0.02, 0.03, 0.04, 0.05, 0.06, 0.08, 0.1, 1.50E-01, 0.2, 0.3, 
							0.4, 0.5, 0.6, 0.8, 1, 1.022, 1.25, 1.5, 2, 2.044, 
							3, 4, 5, 6, 7, 8, 9, 10, 15, 20, 
							50, 100, 500, 1000, 5000, 10000, 50000, 60000, 80000, 100000};
	string Materials[20] = {"Be", "C", "Al", "Si", "Fe", "Ge", "Ag", "Water"};
	double MaterialsAtomicNum[20] = {101, 26};
	string Processes[4] = {"gamma conversion","Compton effect","photoelectric", "Rayleigh scattering"};

		
	for (int i =7; i<=7;i++)  // loop for materials
	{
		
		std::vector<double>  x_energy; // Nist
		std::vector<double>  y_nist_total; 	
		std::vector<double>  y_nist_pair; 	
		std::vector<double>  y_nist_compt; 	
		std::vector<double>  y_nist_phot; 	
		std::vector<double>  y_nist_rayl; 	
		// to remove repeated points
		
		std::vector<double>  y_epics2017_total; // EPICS2017
		std::vector<double>  y_epics2017_pair; 	
		std::vector<double>  y_epics2017_compt; 	
		std::vector<double>  y_epics2017_phot; 	
		std::vector<double>  y_epics2017_rayl; 
		std::vector<double>  uncertainty_epics2017; 
		
		std::vector<double>  y_livermore_total; // Livermore
		std::vector<double>  y_livermore_pair; 	
		std::vector<double>  y_livermore_compt; 	
		std::vector<double>  y_livermore_phot; 	
		std::vector<double>  y_livermore_rayl;
		std::vector<double>  uncertainty_livermore;

		
		
		//read Nist data begin***************************************************
		std::ostringstream ost1;
		// ost1 << "XCOM_data/Water.dat";
		ost1 << "XCOM_data/"<<Materials[i]<<".dat";
		// cout<<ost1.str()<<endl;
		std::ifstream fin1(ost1.str().c_str());
		for(int i = 0; i<80; ++i) 
		{
			double P[7] = {0};
			fin1 >> P[0] >> P[1]>> P[2] >> P[3]>>P[4] >> P[5]>> P[6];
			
			for(int i = 0; i<50; i++)
			{
				if(P[0] == energies[i])
				{
					static int j = 0;
					// printf("1---%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					// ++j, P[0], P[1], P[2], P[3], P[4], P[5], P[6]);
					x_energy.push_back(P[0]);
					y_nist_total.push_back(P[6]);
					y_nist_rayl.push_back(P[1]);
					y_nist_compt.push_back(P[2]);
					y_nist_phot.push_back(P[3]);
					y_nist_pair.push_back(P[4]+P[5]);
					break;
				}
				 
				 
			}	
		 
		}		
			
	   fin1.close();
	   //read Nist data end***************************************************
		
		//read EPICS2017 data begin***************************************************
		std::ostringstream ost2;
		// ost2 << "epics2017_data/AttenuationCoefficient_Water_epics2017.dat";
		ost2 << "epics2017_data/AttenuationCoefficient_"<<Materials[i]<<"_epics2017.dat";
		std::ifstream fin2(ost2.str().c_str());
		int loop = 0;
		for(int i = 0; i<50; i++)
		{
			double P[17] = {0};
			fin2 >> P[0] >> P[1]>> P[2] >> P[3]>>P[4] >> P[5]>> P[6]
			>> P[7] >> P[8]>> P[9] >> P[10] >> P[11]>> P[12] >> P[13]
			>>P[14] >> P[15]>> P[16];		
			
			// printf("2---%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					// i+1, P[0], P[1], P[2], P[3], P[4], P[5], P[6],
					// P[7], P[8], P[9], P[10], P[11], P[12], P[13],
					// P[14], P[15], P[16]);
					
			y_epics2017_total.push_back(P[1]);
			uncertainty_epics2017.push_back(P[6]);
			if(IsEqual1(P[11], P[16], eps1, releps1)) 
			{
				// cout<<"**********"<<P[0]<<" "<<P[11]<<" "<<P[16]<<endl;
				y_epics2017_rayl.push_back(P[10]);
				y_epics2017_compt.push_back(P[8]);
				y_epics2017_phot.push_back(P[7]);
				y_epics2017_pair.push_back(P[9]);
				loop++;
			}		
			
			 
		}
		// cout<<"loop == "<<loop<<endl;
		if(loop == 50) 
		{
			printf("-----------------Two computeCS methods turn the same results for EPICS2017\n");
		}
		fin2.close();
	   //read EPICS217 data end***************************************************
	
	
	
		// read Livermore data begin***************************************************
		std::ostringstream ost3;
		// ost3 << "livermore_data/AttenuationCoefficient_Water_livermore.dat";
		ost3 << "livermore_data/AttenuationCoefficient_"<<Materials[i]<<"_livermore.dat";
		std::ifstream fin3(ost3.str().c_str());
		loop = 0;
		for(int i = 0; i<50; i++)
		{
			double P[17] = {0};
			fin3 >> P[0] >> P[1]>> P[2] >> P[3]>>P[4] >> P[5]>> P[6]
			>> P[7] >> P[8]>> P[9] >> P[10] >> P[11]>> P[12] >> P[13]
			>>P[14] >> P[15]>> P[16];		
			
			// printf("3---%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					// i+1, P[0], P[1], P[2], P[3], P[4], P[5], P[6],
					// P[7], P[8], P[9], P[10], P[11], P[12], P[13],
					// P[14], P[15], P[16]);
					
			y_livermore_total.push_back(P[1]);
			uncertainty_livermore.push_back(P[6]);
			if(IsEqual1(P[11], P[16], eps1, releps1)) 
			{
				// cout<<"**********"<<P[0]<<" "<<P[11]<<" "<<P[16]<<endl;
				y_livermore_rayl.push_back(P[10]);
				y_livermore_compt.push_back(P[8]);
				y_livermore_phot.push_back(P[7]);
				y_livermore_pair.push_back(P[9]);
				loop++;
			}
			
			
			
			 
		}
		
		if(loop == 50) 
		{
			printf("-----------------Two computeCS methods turn the same results for Livermore\n");
		}
		fin3.close();
	   // read Livermore data end***************************************************
	   // cout<<x_energy.size()<<" "<< y_nist_total.size()<<" "<<y_epics2017_total.size()<<" "<<y_livermore_total.size()<<endl;
	   // for(int i=0; i<50; ++i)
	   // {
		   // printf("%d %.9e %.9e %.9e %.9e\n", i+1, x_energy[i], y_nist_total[i], y_epics2017_total[i], y_livermore_total[i]);
	   // }
	   
		plot_totalMassAttenuation(x_energy,y_nist_total, y_epics2017_total,y_livermore_total,Materials[i]);
		plot_Partial(x_energy,y_nist_pair, y_epics2017_pair,y_livermore_pair,Materials[i],Processes[0]);
		plot_Partial(x_energy,y_nist_compt, y_epics2017_compt,y_livermore_compt,Materials[i],Processes[1]);
		plot_Partial(x_energy,y_nist_phot, y_epics2017_phot,y_livermore_phot,Materials[i],Processes[2]);
		plot_Partial(x_energy,y_nist_rayl, y_epics2017_rayl,y_livermore_rayl,Materials[i],Processes[3]);
		

	  // write total mass attenuation in a file for the use of calculating P value of epics2017 begin***************			
		std::ostringstream ost_epics2017;
		// ost1 << "XCOM_data/Water.dat";
		ost_epics2017 << "./pValue/"<<Materials[i]<<"_epics2017.dat";
		ofstream outFile_epics2017(ost_epics2017.str().c_str(), ios::out);
		outFile_epics2017.setf(ios::scientific);
		
		// outFile_epics2017<<setprecision(9)<<"XCOM"<<"\t"<<
			// "EPICS2017"<<endl;
		outFile_epics2017<<setprecision(9)<<"EPICS2017"<<"\t"<<"Uncertainty"<<"\t"<<"XCOM"<<endl;
				
		for(int i =0; i<x_energy.size(); i++)
		{
			// outFile_epics2017<<setprecision(9)<<x_energy[i]<<" "<<y_nist_total[i]<<" "<<
			// y_epics2017_total[i]<<" "<<y_livermore_total[i]<<endl;
			
			// outFile_epics2017<<setprecision(9)<<x_energy[i]<<" "<<y_nist_total[i]<<" "<<
			// y_epics2017_total[i]<<endl;
			
			// outFile_epics2017<<setprecision(9)<<y_nist_total[i]*1000<<"\t"<<
			// y_epics2017_total[i]*1000<<endl;
			
			outFile_epics2017<<setprecision(9)<<y_epics2017_total[i]<<"\t"<<
			uncertainty_epics2017[i]<<"\t"<<y_nist_total[i]<<endl;
			
			
			
		}
			
		 outFile_epics2017.close();
		
		// write total mass attenuation in a file for the use of calculating P value of epics2017 end***************
		
		 // write total mass attenuation in a file for the use of calculating P value of livermore begin***************			
		std::ostringstream ost_livermore;
		// ost1 << "XCOM_data/Water.dat";
		ost_livermore << "pValue/"<<Materials[i]<<"_livermore.dat";
		ofstream outFile_livermore(ost_livermore.str().c_str(), ios::out);
		outFile_livermore.setf(ios::scientific);
		outFile_livermore<<setprecision(9)<<"XCOM"<<"\t"<<
			"Livermore"<<endl;
		for(int i =0; i<x_energy.size(); i++)
		{
			// outFile_livermore<<setprecision(9)<<x_energy[i]<<" "<<y_nist_total[i]<<" "<<
			// y_epics2017_total[i]<<" "<<y_livermore_total[i]<<endl;
			
			// outFile_livermore<<setprecision(9)<<x_energy[i]<<" "<<y_nist_total[i]<<" "<<
			// y_epics2017_total[i]<<endl;
			
			outFile_livermore<<setprecision(9)<<y_nist_total[i]*1000<<"\t"<<
			y_livermore_total[i]*1000<<endl;			
			
		}
			
		 outFile_livermore.close();
		
		// write total mass attenuation in a file for the use of calculating P value of livermore end***************
		
	  	   
	}
	
}	
		
	           
            	
    
   